#!/bin/bash
#WinLinux Kernel Sources Install SHell script

VERSION=2
PATCHLEVEL=2
SUBLEVEL=15
PARAM=""
TYPE=""

#Ask to the user the path to the file
echo -n "Please, type the path to Linux Kernel sources file [/usr/src/linux-"$VERSION"."$PATCHLEVEL"."$SUBLEVEL".tar.gz]:"
read wlkspath
if [ -z "$wlkspath" ] ; then
   wlkspath="/usr/src/linux-"$VERSION"."$PATCHLEVEL"."$SUBLEVEL".tar.gz"
fi
#Check the type of compression, and confirm the sources version

echo "Checking file, please wait..."

TYPE=`file -b "$wlkspath" |cut -d" " -f1`
echo " Hmm, tar archive compressed with "$TYPE"."
if [ "$TYPE" = "bzip2" ] ; then
    PARAM="-xyvf"
elif [ "$TYPE" = "gzip" ] ; then
   PARAM="-xzvf"
else
   echo " Hmm, this doesn't look like a tar archive."
   echo " Please, make sure that you have a .tar.bz2, .tar.gz or .tgz file"
fi

#Get the Kernel Release, delete the temp files and warn the user about the release

tar "$PARAM" "$wlkspath" -C /tmp linux/Makefile

VERSION=`cat /tmp/linux/Makefile |grep "VERSION =" |head -1 |cut -d" " -f3`
PATCHLEVEL=`cat /tmp/linux/Makefile |grep "PATCHLEVEL =" |head -1 |cut -d" " -f3`
SUBLEVEL=`cat /tmp/linux/Makefile |grep "SUBLEVEL =" |head -1 |cut -d" " -f3`

#rm -f /tmp/linux/*
#rmdir /tmp/linux

echo "Linux kernel release is "$VERSION"."$PATCHLEVEL"."$SUBLEVEL""

#Finally, install the sources in correct local and create symlinks

if [ -h /usr/src/linux ] ; then
   rm -f /usr/src/linux
elif [ -d /usr/src/linux ] ; then
   mv /usr/src/linux /usr/src/old-linux
fi
tar "$PARAM" "$wlkspath" -C /usr/src
mv /usr/src/linux /usr/src/linux-"$VERSION"."$PATCHLEVEL"."$SUBLEVEL"
ln -s  /usr/src/linux-"$VERSION"."$PATCHLEVEL"."$SUBLEVEL" /usr/src/linux

#That's all folk's!
